#! /usr/bin/env python
# Semplice scritp di interrogazione di LDAP per impostare i dati 
# delle quote degli utenti
#
# Copyright (C) 2005 Simone Piccardi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import ldap
from os import *
from sys import *

if len(argv) != 3:
    print "Wrong parameter number"
    print "use ./setuserquota.py soft_block_limit hard_block_limit"
    exit(1)

try: 
    l = ldap.open("127.0.0.1")
    l.protocol_version = ldap.VERSION3
    username = "cn=admin,dc=scuola,dc=local"
    password = "pippo"
    l.simple_bind(username, password)

except ldap.LDAPError, e:
    print "Connection error", e

baseDN = "ou=Users,dc=scuola,dc=local"
searchScope = ldap.SCOPE_ONELEVEL
searchFilter = "uid=*"
retrieveAttributes = ["uid", "uidNumber"]

try:
    ldap_result_id = l.search(baseDN, searchScope, searchFilter, retrieveAttributes)
    result_set = []
    count = 0
    while 1:
	result_type, result_data = l.result(ldap_result_id, 0)
	if (result_data == []):
	    break
	else:
	    if result_type == ldap.RES_SEARCH_ENTRY:
		result_set.append(result_data)
#    print result_set
except ldap.LDAPError, e:
    print "Search error", e
    
if len(result_set) == 0:
    print "No Results from LDAP"
    exit(1)


for i in range(len(result_set)):
    for voce in result_set[i]:
	userid  = voce[1]['uidNumber'][0]
	utente = voce[1]['uid'][0]
	if (int(userid) > 1000):
	    system('/usr/sbin/setquota '+utente+' '+argv[1]+' '+argv[2]+' 0 0 /home/')
